﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls.TreeView;

namespace SilverlightApplication42
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.DataContext = new ObservableCollection<Category>(from c in Enumerable.Range(0, 10) select new Category { Id = c, Name = "Name" + c, Products = new ObservableCollection<Product>(from p in Enumerable.Range(0, c) select new Product { CategoryID = "sd" + p, ProductID = "ID" + p, ProductName = "ProductName" + p }) });

            RadDragAndDropManager.AddDragInfoHandler(SampleTree, OnDragInfo);
        }

        public bool DragCueTemplateLoaded { get; set; }


        public void OnDragInfo(object sender, DragDropEventArgs args)
        {
            var dragCue = args.Options.DragCue as TreeViewDragCue;


            if (dragCue != null)
            {
                dragCue.ItemTemplate = this.Resources["ProductDragCue"] as DataTemplate;
            }
        }
    }

    public class Category
    {
        private string _name;
        private int _id;

        public string Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
            }
        }

        public int Id
        {
            get
            {
                return this._id;
            }
            set
            {
                this._id = value;
            }
        }


        public ObservableCollection<Product> Products
        {
            get;
            set;
        }
    }

    public class Product
    {
        private string productID;
        private string categoryID;
        private string productName;
        private string unitsInStack;
        private string unitPrice;

        /// <summary>
        /// Gets or sets the orderID.
        /// </summary>
        /// <value>The order ID.</value>
        public string ProductID
        {
            get
            {
                return productID;
            }
            set
            {
                productID = value;
            }
        }

        public string CategoryID
        {
            get
            {
                return categoryID;
            }
            set
            {
                categoryID = value;
            }
        }

        /// <summary>
        /// Gets or sets the name of the company.
        /// </summary>
        /// <value>The name of the company.</value>
        public string UnitsInStack
        {
            get
            {
                return unitsInStack;
            }
            set
            {
                unitsInStack = value;
            }
        }

        /// <summary>
        /// Gets or sets the country.
        /// </summary>
        /// <value>The country.</value>
        public string UnitPrice
        {
            get
            {
                return unitPrice;
            }
            set
            {
                unitPrice = value;
            }
        }

        public string ProductName
        {
            get
            {
                return productName;
            }
            set
            {
                productName = value;
            }
        }
    }
}
